app/views/catalogo_cer.py
import json
from flask import Blueprint, render_template, request, current_app
from app.utils.mixins import set_session, get_session, set_multi_session
from datetime import datetime

APP_CONFIG = current_app.config
api_client = APP_CONFIG['API_CLIENT']

CatalogoCertificaciones = Blueprint('CatalogoCertificaciones', __name__)

@CatalogoCertificaciones.route('/catalogo/certificaciones', methods=['GET'])
def explore():
    set_multi_session({
        'SelMenu': 'Certificaciones',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelCriterioCodigo': '',
        'SelCriterioNombre': ''
    })

    # Cargar ejes para filtro
    r_ejes = get_api_filter('ejes')
    set_session('Ejes', r_ejes)

    # Cargar criterios para filtro
    r_criterios = get_api_filter('criterios')
    set_session('Criterios', r_criterios)

    # Cargar listado de documentos
    r_listado = api_client.get(
        endpoint='certificaciones'
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/certificaciones/explorar.html',
        titulo='Explorar Certificaciones',
        filtro_tit='',
        filtro_cat='',
        filtro_tag='',
        datos=r_listado,
        ejes=r_ejes,
        criterios=r_criterios,
        datos_json=json.dumps(r_listado)
    )


@CatalogoCertificaciones.route('/catalogo/certificaciones/eje', methods=['GET'])
def explore_x_eje():
    eje = request.args.get('codigo')

    set_multi_session({
        'SelMenu': 'Certificaciones',
        'SelEjeCodigo': eje,
        'SelCriterioCodigo': '',
        'SelCriterioNombre': ''
    })

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')
    s_eje = api_client.get(
        endpoint='ejes/' + eje
    )
    set_session('SelEjeNombre', s_eje['nombre'])

    # Cargar criterios para filtro
    r_criterios = get_session_filter('Criterios', 'criterios')

    # Cargar listado de documentos x eje
    r_listado = api_client.get(
        endpoint='certificaciones/eje/' + eje
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/certificaciones/explorar.html',
        titulo='Explorar Certificaciones',
        filtro_tit='Filtro por eje: ' + s_eje['nombre'],
        filtro_cat='eje',
        filtro_tag=s_eje['nombre'],
        datos=r_listado,
        ejes=r_ejes,
        criterios=r_criterios,
        datos_json=json.dumps(r_listado)
    )


@CatalogoCertificaciones.route('/catalogo/certificaciones/criterio', methods=['GET'])
def explore_x_criterio():
    criterio = request.args.get('codigo')

    set_multi_session({
        'SelMenu': 'Certificaciones',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelCriterioCodigo': criterio
    })

    # Cargar criterios para filtro
    r_criterios = get_session_filter('Criterios', 'criterios')
    s_criterio = api_client.get(
        endpoint='criterios/' + criterio
    )
    set_session('SelCriterioNombre', s_criterio['nombre'])

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')

    # Cargar listado de documentos x tipo
    r_listado = api_client.get(
        endpoint='certificaciones/criterio/' + criterio
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/certificaciones/explorar.html',
        titulo='Explorar Certificaciones',
        filtro_tit='Filtro por criterio: ' + s_criterio['nombre'],
        filtro_cat='criterio',
        filtro_tag=s_criterio['nombre'],
        datos=r_listado,
        ejes=r_ejes,
        criterios=r_criterios,
        datos_json=json.dumps(r_listado)
    )


# Cargar datos para los filtros de selección
def get_session_filter(session_var, end_point):
    data = get_session(session_var)
    if not data:
        data = get_api_filter(end_point)
    return data

def get_api_filter(end_point):
    data = api_client.get(
        endpoint=end_point
    )
    if not data:
        data = {}
    return data

app/views/catalogo_doc.py
import json
from flask import Blueprint, render_template, request, current_app
from app.utils.mixins import set_session, get_session, set_multi_session


APP_CONFIG = current_app.config
api_client = APP_CONFIG['API_CLIENT']

CatalogoDocumentos = Blueprint('CatalogoDocumentos', __name__)

@CatalogoDocumentos.route('/catalogo/documentos', methods=['GET'])
def explore():
    set_multi_session({
        'SelMenu': 'Documentos',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelTipoCodigo': '',
        'SelTipoNombre': '',
        'SelCategoria': '',
        'SelEtiqueta': ''
    })

    # Cargar ejes para filtro
    r_ejes = get_api_filter('ejes')
    set_session('Ejes', r_ejes)

    # Cargar tipos de documentos para filtro
    r_tiposdoc = get_api_filter('tipos-documentos')
    set_session('TiposDoc', r_tiposdoc)

    # Cargar etiquetas para filtro
    r_etiquetas = get_api_filter('documentos/etiquetas')
    set_session('Etiquetas', r_etiquetas)

    # Cargar listado de documentos
    r_listado = api_client.get(
        endpoint='documentos'
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/documentos/explorar.html',
        titulo='Explorar Documentos',
        filtro_tit='',
        filtro_cat='',
        filtro_tag='',
        datos=r_listado,
        ejes=r_ejes,
        tipos=r_tiposdoc,
        etiquetas=r_etiquetas,
        datos_json=json.dumps(r_listado)
    )


@CatalogoDocumentos.route('/catalogo/documentos/eje', methods=['GET'])
def explore_x_eje():
    eje = request.args.get('codigo')

    set_multi_session({
        'SelMenu': 'Documentos',
        'SelEjeCodigo': eje,
        'SelTipoCodigo': '',
        'SelTipoNombre': '',
        'SelCategoria': '',
        'SelEtiqueta': ''
    })

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')
    s_eje = api_client.get(
        endpoint='ejes/' + eje
    )
    set_session('SelEjeNombre', s_eje['nombre'])

    # Cargar tipos de documentos para filtro
    r_tiposdoc = get_session_filter('TiposDoc', 'tipos-documentos')

    # Cargar tipos de documentos para filtro
    r_etiquetas = get_session_filter('Etiquetas', 'documentos/etiquetas')

    # Cargar listado de documentos x eje
    r_listado = api_client.get(
        endpoint='documentos/eje/' + eje
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/documentos/explorar.html',
        titulo='Explorar Documentos',
        filtro_tit='Filtro por eje: ' + s_eje['nombre'],
        filtro_cat='eje',
        filtro_tag=s_eje['nombre'],
        datos=r_listado,
        ejes=r_ejes,
        tipos=r_tiposdoc,
        etiquetas=r_etiquetas,
        datos_json=json.dumps(r_listado)
    )


@CatalogoDocumentos.route('/catalogo/documentos/tipo', methods=['GET'])
def explore_x_tipo():
    tipo = request.args.get('codigo')

    set_multi_session({
        'SelMenu': 'Documentos',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelTipoCodigo': tipo,
        'SelCategoria': '',
        'SelEtiqueta': ''
    })

    # Cargar tipos de documentos para filtro
    r_tiposdoc = get_session_filter('TiposDoc', 'tipos-documentos')
    s_tipo = api_client.get(
        endpoint='tipos-documentos/' + tipo
    )
    set_session('SelTipoNombre', s_tipo['nombre'])

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')

    # Cargar tipos de documentos para filtro
    r_etiquetas = get_session_filter('Etiquetas', 'documentos/etiquetas')

    # Cargar listado de documentos x tipo
    r_listado = api_client.get(
        endpoint='documentos/tipo/' + tipo
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/documentos/explorar.html',
        titulo='Explorar Documentos',
        filtro_tit='Filtro por tipo: ' + s_tipo['nombre'],
        filtro_cat='tipo',
        filtro_tag=s_tipo['nombre'],
        datos=r_listado,
        ejes=r_ejes,
        tipos=r_tiposdoc,
        etiquetas=r_etiquetas,
        datos_json=json.dumps(r_listado)
    )


@CatalogoDocumentos.route('/catalogo/documentos/categoria', methods=['GET'])
def explore_x_categoria():
    tag = request.args.get('tag')

    set_multi_session({
        'SelMenu': 'Documentos',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelTipoCodigo': '',
        'SelTipoNombre': '',
        'SelCategoria': tag,
        'SelEtiqueta': ''
    })

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')

    # Cargar tipos de documentos para filtro
    r_tiposdoc = get_session_filter('TiposDoc', 'tipos-documentos')

    # Cargar etiquetas para filtro
    r_etiquetas = get_session_filter('Etiquetas', 'documentos/etiquetas')

    # Cargar listado de documentos x categoria
    r_listado = api_client.get(
        endpoint='documentos/categoria/' + tag
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/documentos/explorar.html',
        titulo='Explorar Documentos',
        filtro_tit='Filtro por categoría: ' + tag,
        filtro_cat='categoria',
        filtro_tag=tag,
        datos=r_listado,
        ejes=r_ejes,
        tipos=r_tiposdoc,
        etiquetas=r_etiquetas,
        datos_json=json.dumps(r_listado)
    )


@CatalogoDocumentos.route('/catalogo/documentos/etiqueta', methods=['GET'])
def explore_x_etiqueta():
    tag = request.args.get('tag')

    set_multi_session({
        'SelMenu': 'Documentos',
        'SelEjeCodigo': '',
        'SelEjeNombre': '',
        'SelTipoCodigo': '',
        'SelTipoNombre': '',
        'SelCategoria': '',
        'SelEtiqueta': tag
    })

    # Cargar ejes para filtro
    r_ejes = get_session_filter('Ejes', 'ejes')

    # Cargar tipos de documentos para filtro
    r_tiposdoc = get_session_filter('TiposDoc', 'tipos-documentos')

    # Cargar etiquetas para filtro
    r_etiquetas = get_session_filter('Etiquetas', 'documentos/etiquetas')

    # Cargar listado de documentos x etiqueta
    r_listado = api_client.get(
        endpoint='documentos/etiqueta/' + tag
    )
    if not r_listado:
        r_listado = {}

    return render_template(
        'public/documentos/explorar.html',
        titulo='Explorar Documentos',
        filtro_tit='Filtro por etiqueta: ' + tag,
        filtro_cat='etiqueta',
        filtro_tag=tag,
        datos=r_listado,
        ejes=r_ejes,
        tipos=r_tiposdoc,
        etiquetas=r_etiquetas,
        datos_json=json.dumps(r_listado)
    )


# Cargar datos para los filtros de selección
def get_session_filter(session_var, end_point):
    data = get_session(session_var)
    if not data:
        data = get_api_filter(end_point)
    return data

def get_api_filter(end_point):
    data = api_client.get(
        endpoint=end_point
    )
    if not data:
        data = {}
    return data

app/views/home.py
from flask import Blueprint, render_template, current_app, request, session, send_file, flash, redirect, url_for
from app.utils.mixins import current_date, get_session, set_multi_session, set_session, random_secret
from app.utils.constants import MESSAGES
from app.utils.logic import set_parametros_encuesta, set_parametros_responsable

APP_CONFIG = current_app.config
api_client = APP_CONFIG['API_CLIENT']

Home = Blueprint('Home', __name__)

@Home.route('/')
@Home.route('/inicio')
def index():
    set_multi_session({
        'SelMenu': 'Inicio',
        'SelEjeNombre': '',
        'SelTipoNombre': '',
        'SelCategoria': '',
        'SelCriterio': '',
        'SelEtiqueta': '',
        'ConfigRol': 'Usuario',
        'ThemeColor': 'blue'
    })

    return render_template('inicio.html')

app/views/usuarios.py
import json
from flask import Blueprint, render_template, redirect, url_for, flash, request, current_app
from app.utils.mixins import current_date, get_session, set_session, sha256_hash
from app.utils.constants import MESSAGES

APP_CONFIG = current_app.config
api_client = APP_CONFIG['API_CLIENT']

Usuarios = Blueprint('Usuarios', __name__)


@Usuarios.route('/usuarios', methods=['GET', 'POST'])
def list_usuarios():
    # Setear menú Administración
    set_session('SelMenu', 'Administración')

    # Cargar listado
    r_listado = api_client.get(
        endpoint='usuarios'
    )
    if not r_listado:
        r_listado = {}

    #print(r_listado)

    return render_template(
        'admin/usuarios/listar.html',
        titulo='Gestionar Usuarios',
        acciones='edit,delete',
        datos=r_listado,
        datos_json=json.dumps(r_listado)
    )


@Usuarios.route('/usuarios/accion', methods=['GET', 'POST'])
def action_usuario():
    action = request.args.get('dbAction')
    item = request.form.to_dict()
    item['clave'] = sha256_hash(str(item['clave']))

    if action == 'create':
        endpoint_ = 'usuarios'
        api_client.post(
            endpoint=endpoint_,
            body=item
        )
        flash(MESSAGES.SUCCESS_CREATING_RECORD, 'success')
    elif action == 'update':
        identificacion = str(item.pop('identificacion'))
        endpoint_ = 'usuarios/' + identificacion
        api_client.put(
            endpoint=endpoint_,
            body=item
        )
        flash(MESSAGES.SUCCESS_UPDATING_RECORD, 'success')

    return redirect(url_for('Usuarios.list_usuarios'))


#Recibe el id del responsable desde la lista
@Usuarios.route('/usuarios/borrar', methods=['GET', 'POST'])
def delete_usuario():
    endpoint_ = 'usuarios/' + request.args.get('identificacion')
    response = api_client.delete(
        endpoint=endpoint_
    )
    if response:
        flash(MESSAGES.SUCCESS_DELETING_RECORD, 'success')
    else:
        flash(MESSAGES.FAIL_DELETING_RECORD, 'danger')

    return redirect(url_for('Usuarios.list_usuarios'))


#Recibe el id del responsable desde la lista
@Usuarios.route('/usuarios/clave', methods=['GET', 'POST'])
def key_usuario():
    # Setear menú Administración
    set_session('SelMenu', 'Cuenta')

    return render_template(
        'admin/usuarios/actualizar.html',
        titulo='Cambiar Clave',
        acciones='edit'
    )


#Recibe la clave nueva
@Usuarios.route('/usuarios/clave/actualizar', methods=['POST'])
def updatekey_usuario():
    item = dict(request.values)
    identificacion = get_session('UserId')

   # Cargar usuario
    r_user = api_client.get(
        endpoint='usuarios/' + identificacion
    )
    del r_user['identificacion']
    r_user['clave'] = sha256_hash(str(item['new_clave']))

    response = api_client.put(
        endpoint='usuarios/' + identificacion,
        body=r_user
    )
    if response:
        flash(MESSAGES.SUCCESS_CHANGING_KEY, 'success')
    else:
        flash(MESSAGES.FAIL_CHANGING_KEY, 'danger')

    return redirect(url_for('Home.index'))

app/templates/components/footer.html
<!-- ======= Footer ======= -->
<footer id="footer" style="margin-top: auto;">
  <div class="container">
    <div class="copyright">
      <span id="curretYear"></span> &copy; Copyright Todos los derechos reservados
      <script>
        var currentYear = new Date().getFullYear();
        document.getElementById('curretYear').innerHTML = currentYear;
      </script>
    </div>
    <div class="credits">
      <!-- All the links in the footer should remain intact. -->
      <!-- You can delete the links only if you purchased the pro version. -->
      <!-- Licensing information: https://bootstrapmade.com/license/ -->
      <!-- Purchase the pro version with working PHP/AJAX contact form: https://bootstrapmade.com/eterna-free-multipurpose-bootstrap-template/ -->
      <small>Designed by <a href="https://bootstrapmade.com/">BootstrapMade</a></small>
    </div>
  </div>
</footer><!-- End Footer -->

<a href="#" class="back-to-top"><i class="icofont-simple-up"></i></a>

app/templates/components/header.html
<!-- ======= Header ======= -->
<header id="header" class="fixed-top">
    <div class="container-fluid">
        <div class="row justify-content-center">
            <div class="col-xl-10 d-flex align-items-center">

                <h1 class="logo mr-auto">
                    <img src="{{ url_for('static', filename='dist/img/alcaldia.png') }}" alt="">
                    <a  class="ml-3" href="{{ url_for('Home.index') }}">
                        BANCO DE<br><span class="ml-3">INFORMACIÓN</span>
                    </a>
                </h1>

                <nav class="nav-menu d-none d-lg-block">
                    <ul>
                        <!-- Menu Público: para cualquier usuario invitado  -->
                        <li><a href="{{ url_for('CatalogoDocumentos.explore') }}"
                            class="{% if session['baninfo_SelMenu']=='Documentos' %} active {% endif %}">
                            <i class="icofont-files-stack"></i>&nbsp;DOCUMENTOS</a>
                        </li>
                        <li><a href="{{ url_for('CatalogoOrganizaciones.explore') }}"
                            class="{% if session['baninfo_SelMenu']=='Organizaciones' %} active {% endif %}">
                            <i class="icofont-address-book"></i>&nbsp;ORGANIZACIONES</a>
                        </li>
                        <li><a href="{{ url_for('CatalogoCertificaciones.explore') }}"
                            class="{% if session['baninfo_SelMenu']=='Certificaciones' %} active {% endif %}">
                            <i class="icofont-ebook"></i>&nbsp;CERTIFICACIONES</a>
                        </li>
                        <!-- Menu Usuario: para cualquier usuario logueado  -->
                        {% if session['baninfo_UserNombre'] %}
                        <li class="drop-down dropdown-menu-right"><a class="{% if session['baninfo_SelMenu']=='Administración' %} active {% endif %}">
                            <i class="icofont-gear"></i>&nbsp;ADMINISTRACIÓN</a>
                            <ul>
                                <li><a href="{{ url_for('Documentos.list_documentos') }}">
                                    <i class="icofont-files-stack"></i>&nbsp;Documentos</a>
                                </li>
                                <li><a href="{{ url_for('TiposDocumento.list_tiposdoc') }}">
                                    <i class="icofont-tags"></i>&nbsp;Tipos de Documento</a>
                                </li>
                                <div class="dropdown-divider"></div>
                                <li><a href="{{ url_for('Ejes.list_ejes') }}">
                                    <i class="icofont-chart-flow"></i>&nbsp;Ejes</a>
                                </li>
                                <div class="dropdown-divider"></div>
                                <li><a href="{{ url_for('Organizaciones.list_organizaciones') }}">
                                    <i class="icofont-address-book"></i>&nbsp;Organizaciones</a>
                                </li>
                                <li><a href="{{ url_for('Usuarios.list_usuarios') }}">
                                    <i class="icofont-users"></i>&nbsp;Usuarios</a>
                                </li>
                            </ul>
                        </li>

                        <li class="drop-down dropdown-menu-right"><a class="{% if session['baninfo_SelMenu']=='Cuenta' %} active {% endif %}">
                            <i class="icofont-key-hole"></i>&nbsp;CUENTA</a>
                            <ul>
                                <li><span>{{ session['baninfo_UserNombre']|title }}</span></li>
                                <li><span>{{ session['baninfo_UserEmail'] }}</span></li>
                                <div class="dropdown-divider"></div>
                                <li><a href="{{ url_for('Usuarios.key_usuario') }}">
                                    <i class="icofont-key"></i>&nbsp;Cambiar Clave</a>
                                </li>
                                <li>
                                    <a href="#logoutModal" data-toggle="modal">
                                    <i class="icofont-logout"></i>&nbsp;Cerrar Sesión</a>
                                </li>
                            </ul>
                        </li>
                        {% else %}<!-- Menu Iniciar Sesión: si no hay usuario logueado  -->
                        <li><a href="#loginModal" data-toggle="modal">
                            <i class="icofont-login"></i>&nbsp;INICIA SESIÓN</a>
                        </li>
                        {% endif %}

                    </ul>
                </nav><!-- .nav-menu -->

            </div>
        </div>

    </div>
</header><!-- End Header -->

<!-- Modal Login -->
{% include 'auth/login.html' %}

<!-- Modal logout -->
{% include 'auth/logout.html' %}

app/templates/components/loading.html
<div class="abc-loading" id="loading">
    <div class="spinner-border text-light" role="status">
        <span class="sr-only">Cargando...</span>
    </div>
    <span class="text-light font-weight-bold my-4">
        Espere por favor...
    </span>
</div>

app/templates/components/messages.html
<div class="container container-fluid">
    <div class="row justify-content-center">
        <div class="d-flex align-items-center flex-column w-100">

<!-- Flash Messages -->
{% with messages = get_flashed_messages(with_categories=true) %}
{% if messages %}

<div class="py-2 w-100">    
    {% for category, message in messages %}
    <div class="alert alert-{{ category }} alert-dismisible mb-2">
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
            <span class="sr-only">Close</span>
        </button>
        {{ message | safe }}
    </div>
    {% endfor %}

</div>
{% endif %}
{% endwith %}

</div></div></div>

app/templates/components/topbar.html
<!-- ======= Top Bar ======= -->
<section id="topbar" class="d-none d-lg-block">
    <div class="container-fluid">
        <div class="row justify-content-center">
            <div class="col-xl-10 d-flex align-items-center">
                <div class="contact-info mr-auto">
                    <i class=""></i>{{ fecha }}
                </div>
                <div class="contact-info" style="float:right;">

                    <!-- Usuario Logueado  -->
                    {% if session['baninfo_NombreUsuario']%}
                    <i class="icofont-id-card"></i>{{session['baninfo_NombreUsuario']}}
                    <i class="icofont-logout"></i><a href="#logoutModal" data-toggle="modal" onclick="detectarCambios()">Cerrar
                        Sesión</a>
                    {% else %}
                    <a href="#loginModal" data-toggle="modal"><i class="icofont-login"></i>&nbsp;Iniciar Sesión</a>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
</section>